/*
    Pirate Bulletin Board System
    Copyright (C) 1990, Edward Luke, lush@Athena.EE.MsState.EDU
    Eagles Bulletin Board System
    Copyright (C) 1992, Raymond Rocker, rocker@rock.b11.ingr.com
                        Guy Vega, gtvega@seabass.st.usm.edu
                        Dominic Tynes, dbtynes@seabass.st.usm.edu

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include "osdeps.h"
#include "io.h"
#include "myctype.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>

int
readln(fp,buf)
FILE *fp ;
char *buf ;
{
    int i, j, k ;
    int ch ;
    int bytes ;
    extern int t_columns;

    i = 0 ;
    bytes = 0 ;
    while((ch = getc(fp)) != EOF) {
        bytes++ ;
        if(ch == '\n') {
            buf[i] = '\0' ;
            return bytes ;
        }
        if(ch == '\t') {
          k = (8 - (i % 8));
          if(k == 0) k = 8;
          for(j=0;j<k;j++) {
            buf[i++] = ' ';
            if(i == t_columns) {
              buf[i] = '\0' ;
              return bytes ;
            }
          }
        }
        if(myisprint(ch))
            buf[i++] = ch ;
        if(i == t_columns) {
            buf[i] = '\0' ;
            return bytes ;
        }
    }
    if(i == 0)
      return 0 ;
    else {
        buf[i] = '\0' ;
        return bytes ;
    }
}

int
more(filename,promptend)
char *filename ;
{
    FILE *fp ;
    int ch ;
    int i, j ;
    int viewed, pos ;
    long tsize ;
    struct stat st ;
    int numbytes ;
    int pagebreaks[1024];
    int pageno, linectr;
    char buf[129] ;
    char **page;
    extern int t_lines ;
    memset(pagebreaks, 0, sizeof(pagebreaks));

    if((fp = fopen(filename,"r")) == NULL) {
        return -1;
    }
    if(fstat(fileno(fp), &st)) {
        return -1;
    }
    tsize = st.st_size ;
    clear() ;

    if ((page = (char**)calloc(t_lines, sizeof(char*))) == NULL)
	return -1;
    for (i=0; i<t_lines-1; i++) {
	if ((page[i] = (char*) calloc (1, 129)) == NULL) {
	    for (; (i); i--) {
		if (page[i]) {
		    free(page[i]);
		    page[i] = NULL;
		}
	    }
	    free(page);
	    page = NULL;
	    return -1;
	}
    }

    i = 0 ;
    pos = 0 ;
    viewed = 0 ;
    pageno = linectr = 0;

    numbytes = readln(fp,buf) ;
    do {
        if(!numbytes)
          break ;
        viewed += numbytes ;
        if(pos == t_lines - 1) {
	    move (0, 0);
	    clrtobot();
	    for (j=1; j<pos; j++) {
		prints("%s\n", page[j]);
		if (*page[j])
		    strcpy(page[j-1], page[j]);
		else
		   *page[j-1] = '\0';
	    }
            pos-- ;
        }
        prints("%s\n",buf) ;
	if (*buf)
	    strcpy(page[pos], buf);
	else
	    *page[pos] = '\0';
        i++ ;
        pos++ ;
        if (++linectr == t_lines) {
            if (++pageno < 1024) pagebreaks[pageno] = viewed;
            linectr = 0;
        }
        numbytes = readln(fp,buf) ;
        if(!numbytes)
          break ;
        if(i == t_lines-1) {
            move(t_lines-1,0) ;
            if(!dumb_term) {
		extern int lang;

                standout() ;
		if (lang)
                  prints("--  -- (%d%%)",(viewed*100)/tsize) ;
		else
                  prints("--More-- (%d%%)",(viewed*100)/tsize) ;
                standend() ;
            } else
              bell() ;
            while((ch = igetch()) != EOF) {
                if(ch == ' ') {
                    move(t_lines-1,0) ;
                    clrtobot() ;
                    refresh() ;
                    i = 1 ;
                    break ;
                }
                if(ch == 'q') {
                    move(t_lines-1,0) ;
                    clrtobot() ;
                    refresh() ;
                    fclose(fp) ;
		    for (j=0; j<t_lines-1; j++) {
		      free(page[j]);
		    }
		    free(page);
                    return  0;
                }
                if(ch == '\r') {
                    move(t_lines-1,0) ;
                    clrtobot() ;
                    refresh() ;
                    i = t_lines-2 ;
                    break ;
                }
                if(ch == 'b') {
		    if (pageno >= 1 && pageno < 1024 && viewed < tsize) {
		        pageno--;
			viewed = pagebreaks[pageno];
		        fseek(fp, viewed, SEEK_SET);
			move(t_lines-1,0);
			clrtobot();
			i = linectr = 0;
			numbytes = readln(fp, buf);
			break;
		    }
                }
                bell() ;
            }
        }
    } while(numbytes) ;
    fclose(fp) ;
    move(t_lines-1,0) ;
    if(promptend)
      pressreturn() ;
    for (j=0; j<t_lines-1; j++) {
      free(page[j]);
    }
    free(page);
    return 0 ;
}
